/[gentoo-x86]/eclass/linux-mod.eclass
Gentoo

Diff of /eclass/linux-mod.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.64 Revision 1.108
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-mod.eclass,v 1.64 2006/05/11 08:23:43 johnm Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-mod.eclass,v 1.108 2012/09/15 16:16:53 zmedico Exp $
4 4
5# @ECLASS: linux-mod.eclass
6# @MAINTAINER:
7# kernel-misc@gentoo.org
8# @AUTHOR:
9# John Mylchreest <johnm@gentoo.org>,
10# Stefan Schweizer <genstef@gentoo.org>
11# @BLURB: It provides the functionality required to install external modules against a kernel source tree.
12# @DESCRIPTION:
5# Description: This eclass is used to interface with linux-info in such a way 13# This eclass is used to interface with linux-info.eclass in such a way
6# to provide the functionality required and initial functions 14# to provide the functionality and initial functions
7# required to install external modules against a kernel source 15# required to install external modules against a kernel source
8# tree. 16# tree.
9#
10# Maintainer: John Mylchreest <johnm@gentoo.org>
11# Copyright 2004 Gentoo Linux
12#
13# Please direct your bugs to the current eclass maintainer :)
14 17
15# A Couple of env vars are available to effect usage of this eclass 18# A Couple of env vars are available to effect usage of this eclass
16# These are as follows: 19# These are as follows:
17# 20
18# Env Var Option Default Description 21# @ECLASS-VARIABLE: KERNEL_DIR
19# KERNEL_DIR <string> /usr/src/linux The directory containing kernel 22# @DESCRIPTION:
20# the target kernel sources. 23# A string containing the directory of the target kernel sources. The default value is
21# ECONF_PARAMS <string> The parameters to pass to econf. 24# "/usr/src/linux"
25
26# @ECLASS-VARIABLE: ECONF_PARAMS
27# @DESCRIPTION:
28# It's a string containing the parameters to pass to econf.
22# If this is not set, then econf 29# If this is not set, then econf isn't run.
23# isn't run.
24# BUILD_PARAMS <string> The parameters to pass to emake.
25# BUILD_TARGETS <string> clean modules The build targets to pass to
26# make.
27# MODULE_NAMES <string> This is the modules which are
28# to be built automatically using
29# the default pkg_compile/install.
30# They are explained properly
31# below. It will only make
32# BUILD_TARGETS once in any
33# directory.
34 30
35# MODULE_NAMES - Detailed Overview 31# @ECLASS-VARIABLE: BUILD_PARAMS
32# @DESCRIPTION:
33# It's a string with the parameters to pass to emake.
34
35# @ECLASS-VARIABLE: BUILD_TARGETS
36# @DESCRIPTION:
37# It's a string with the build targets to pass to make. The default value is "clean module"
38
39# @ECLASS-VARIABLE: MODULE_NAMES
40# @DESCRIPTION:
41# It's a string containing the modules to be built automatically using the default
42# src_compile/src_install. It will only make ${BUILD_TARGETS} once in any directory.
36# 43#
37# The structure of each MODULE_NAMES entry is as follows: 44# The structure of each MODULE_NAMES entry is as follows:
45#
38# modulename(libdir:srcdir:objdir) 46# modulename(libdir:srcdir:objdir)
47#
48# where:
49#
50# modulename = name of the module file excluding the .ko
51# libdir = place in system modules directory where module is installed (by default it's misc)
52# srcdir = place for ebuild to cd to before running make (by default it's ${S})
53# objdir = place the .ko and objects are located after make runs (by default it's set to srcdir)
54#
55# To get an idea of how these variables are used, here's a few lines
56# of code from around line 540 in this eclass:
57#
58# einfo "Installing ${modulename} module"
59# cd ${objdir} || die "${objdir} does not exist"
60# insinto /lib/modules/${KV_FULL}/${libdir}
61# doins ${modulename}.${KV_OBJ} || die "doins ${modulename}.${KV_OBJ} failed"
62#
39# for example: 63# For example:
40# MODULE_NAMES="module_pci(pci:${S}/pci:${S}) module_usb(usb:${S}/usb:${S})" 64# MODULE_NAMES="module_pci(pci:${S}/pci:${S}) module_usb(usb:${S}/usb:${S})"
41# 65#
42# what this would do is 66# what this would do is
67#
43# cd ${S}/pci 68# cd "${S}"/pci
44# make ${BUILD_PARAMS} ${BUILD_TARGETS} 69# make ${BUILD_PARAMS} ${BUILD_TARGETS}
45# cd ${S} 70# cd "${S}"
46# insinto /lib/modules/${KV_FULL}/pci 71# insinto /lib/modules/${KV_FULL}/pci
47# doins module_pci.${KV_OBJ} 72# doins module_pci.${KV_OBJ}
48# 73#
49# cd ${S}/usb 74# cd "${S}"/usb
50# make ${BUILD_PARAMS} ${BUILD_TARGETS} 75# make ${BUILD_PARAMS} ${BUILD_TARGETS}
51# cd ${S} 76# cd "${S}"
52# insinto /lib/modules/${KV_FULL}/usb 77# insinto /lib/modules/${KV_FULL}/usb
53# doins module_usb.${KV_OBJ} 78# doins module_usb.${KV_OBJ}
54#
55# if the srcdir isnt specified, it assumes ${S}
56# if the libdir isnt specified, it assumes misc.
57# if the objdir isnt specified, it assumes srcdir
58 79
59# There is also support for automatyed modules.d file generation. 80# There is also support for automated modprobe.d/modules.d(2.4) file generation.
60# This can be explicitly enabled by setting any of the following variables. 81# This can be explicitly enabled by setting any of the following variables.
82
83# @ECLASS-VARIABLE: MODULESD_<modulename>_ENABLED
84# @DESCRIPTION:
85# This is used to disable the modprobe.d/modules.d file generation otherwise the file will be
86# always generated (unless no MODULESD_<modulename>_* variable is provided). Set to "no" to disable
87# the generation of the file and the installation of the documentation.
88
89# @ECLASS-VARIABLE: MODULESD_<modulename>_EXAMPLES
90# @DESCRIPTION:
91# This is a bash array containing a list of examples which should
92# be used. If you want us to try and take a guess set this to "guess".
61# 93#
94# For each array_component it's added an options line in the modprobe.d/modules.d file
62# 95#
63# MODULESD_${modulename}_ENABLED This enables the modules.d file 96# options array_component
64# generation even if we dont 97#
65# specify any additional info. 98# where array_component is "<modulename> options" (see modprobe.conf(5))
66# MODULESD_${modulename}_EXAMPLES This is a bash array containing 99
67# a list of examples which should 100# @ECLASS-VARIABLE: MODULESD_<modulename>_ALIASES
68# be used. If you want us to try and 101# @DESCRIPTION:
69# take a guess. Set this to "guess" 102# This is a bash array containing a list of associated aliases.
70# MODULESD_${modulename}_ALIASES This is a bash array containing 103#
71# a list of associated aliases. 104# For each array_component it's added an alias line in the modprobe.d/modules.d file
72# MODULESD_${modulename}_ADDITIONS This is a bash array containing 105#
73# A list of additional things to 106# alias array_component
74# add to the bottom of the file. 107#
75# This can be absolutely anything. 108# where array_component is "wildcard <modulename>" (see modprobe.conf(5))
109
110# @ECLASS-VARIABLE: MODULESD_<modulename>_ADDITIONS
111# @DESCRIPTION:
112# This is a bash array containing a list of additional things to
113# add to the bottom of the file. This can be absolutely anything.
76# Each entry is a new line. 114# Each entry is a new line.
77# MODULES_${modulename}_DOCS This is a string list which contains
78# the full path to any associated
79# documents for $modulename
80 115
81# The order of these is important as both of linux-info and eutils contain 116# @ECLASS-VARIABLE: MODULESD_<modulename>_DOCS
82# set_arch_to_kernel and set_arch_to_portage functions and the ones in eutils 117# @DESCRIPTION:
83# are deprecated in favor of the ones in linux-info. 118# This is a string list which contains the full path to any associated
84# See http://bugs.gentoo.org/show_bug.cgi?id=127506 119# documents for <modulename>. These files are installed in the live tree.
120
121# @ECLASS-VARIABLE: KV_OBJ
122# @DESCRIPTION:
123# It's a read-only variable. It contains the extension of the kernel modules.
85 124
86inherit eutils linux-info multilib 125inherit eutils linux-info multilib
87EXPORT_FUNCTIONS pkg_setup pkg_postinst src_install src_compile pkg_postrm 126EXPORT_FUNCTIONS pkg_setup pkg_preinst pkg_postinst src_install src_compile pkg_postrm
88 127
89IUSE="" # don't put pcmcia here, rather in the ebuilds that actually support pcmcia 128IUSE="kernel_linux"
90SLOT="0" 129SLOT="0"
91DESCRIPTION="Based on the $ECLASS eclass" 130RDEPEND="kernel_linux? ( virtual/modutils )"
92RDEPEND="virtual/modutils 131DEPEND="${RDEPEND}
93 pcmcia? ( virtual/pcmcia )" 132 sys-apps/sed
94DEPEND="sys-apps/sed 133 kernel_linux? ( virtual/linux-sources )"
95 pcmcia? ( virtual/pcmcia )"
96 134
97# eclass utilities 135# eclass utilities
98# ---------------------------------- 136# ----------------------------------
99 137
100check_vermagic() { 138check_vermagic() {
139 debug-print-function ${FUNCNAME} $*
140
101 local curr_gcc_ver=$(gcc -dumpversion) 141 local curr_gcc_ver=$(gcc -dumpversion)
102 local tmpfile old_chost old_gcc_ver result=0 142 local tmpfile old_chost old_gcc_ver result=0
103 143
104 tmpfile=`find ${KV_DIR}/ -iname "*.o.cmd" -exec grep usr/lib/gcc {} \; -quit` 144 tmpfile=`find "${KV_DIR}/" -iname "*.o.cmd" -exec grep usr/lib/gcc {} \; -quit`
105 tmpfile=${tmpfile//*usr/lib} 145 tmpfile=${tmpfile//*usr/lib}
106 tmpfile=${tmpfile//\/include*} 146 tmpfile=${tmpfile//\/include*}
107 old_chost=${tmpfile//*gcc\/} 147 old_chost=${tmpfile//*gcc\/}
108 old_chost=${old_chost//\/*} 148 old_chost=${old_chost//\/*}
109 old_gcc_ver=${tmpfile//*\/} 149 old_gcc_ver=${tmpfile//*\/}
132 ewarn "to match the kernel, or recompile the kernel first." 172 ewarn "to match the kernel, or recompile the kernel first."
133 die "GCC Version Mismatch." 173 die "GCC Version Mismatch."
134 fi 174 fi
135} 175}
136 176
137unpack_pcmcia_sources() { 177# @FUNCTION: use_m
138 # So while the two eclasses exist side-by-side and also the ebuilds inherit 178# @RETURN: true or false
139 # both we need to check for PCMCIA_SOURCE_DIR, and if we find it, then we 179# @DESCRIPTION:
140 # bail out and assume pcmcia.eclass is working on it. 180# It checks if the kernel version is greater than 2.6.5.
141 [[ -n ${PCMCIA_SOURCE_DIR} ]] && return 1
142
143 if [[ -f "${1}" ]]; then
144 PCMCIA_SOURCE_DIR="${WORKDIR}/pcmcia-cs/"
145
146 ebegin "Decompressing pcmcia-cs sources"
147 mkdir -p ${PCMCIA_SOURCE_DIR}
148 tar -xjf ${1} -C ${PCMCIA_SOURCE_DIR}
149 eend $?
150
151 if [[ -f ${PCMCIA_SOURCE_DIR}/pcmcia-cs-version ]]; then
152 PCMCIA_VERSION=$(cat ${PCMCIA_SOURCE_DIR}/pcmcia-cs-version)
153 einfo "Found pcmcia-cs-${PCMCIA_VERSION}"
154 fi
155 fi
156}
157
158# Dummy function for compatibility.
159pcmcia_configure() { return 0; }
160
161pcmcia_src_unpack() {
162 local pcmcia_tbz="${ROOT}/usr/src/pcmcia-cs/pcmcia-cs-build-env.tbz2"
163
164 # if the kernel has pcmcia support built in, then we just ignore all this.
165 if linux_chkconfig_present PCMCIA; then
166 einfo "Kernel based PCMCIA support has been detected."
167 else
168 if kernel_is 2 4; then
169 unpack_pcmcia_sources ${pcmcia_tbz};
170 else
171 einfo "We have detected that you are running a 2.6 kernel"
172 einfo "but you are not using the built-in PCMCIA support."
173 einfo "We will assume you know what you are doing, but please"
174 einfo "consider using the built in PCMCIA support instead."
175 epause 10
176
177 unpack_pcmcia_sources ${pcmcia_tbz};
178 fi
179 fi
180}
181
182use_m() { 181use_m() {
182 debug-print-function ${FUNCNAME} $*
183
183 # if we haven't determined the version yet, we need too. 184 # if we haven't determined the version yet, we need too.
184 get_version; 185 get_version;
185 186
186 # if the kernel version is greater than 2.6.6 then we should use 187 # if the kernel version is greater than 2.6.6 then we should use
187 # M= instead of SUBDIRS= 188 # M= instead of SUBDIRS=
189 [ ${KV_MAJOR} -eq 3 ] && return 0
188 [ ${KV_MAJOR} -eq 2 -a ${KV_MINOR} -gt 5 -a ${KV_PATCH} -gt 5 ] && \ 190 [ ${KV_MAJOR} -eq 2 -a ${KV_MINOR} -gt 5 -a ${KV_PATCH} -gt 5 ] && \
189 return 0 || return 1 191 return 0 || return 1
190} 192}
191 193
194# @FUNCTION: convert_to_m
195# @USAGE: /path/to/the/file
196# @DESCRIPTION:
197# It converts a file (e.g. a makefile) to use M= instead of SUBDIRS=
192convert_to_m() { 198convert_to_m() {
199 debug-print-function ${FUNCNAME} $*
200
193 if use_m 201 if use_m
194 then 202 then
195 [ ! -f "${1}" ] && \ 203 [ ! -f "${1}" ] && \
196 die "convert_to_m() requires a filename as an argument" 204 die "convert_to_m() requires a filename as an argument"
197 ebegin "Converting ${1/${WORKDIR}\//} to use M= instead of SUBDIRS=" 205 ebegin "Converting ${1/${WORKDIR}\//} to use M= instead of SUBDIRS="
198 sed -i 's:SUBDIRS=:M=:g' ${1} 206 sed -i 's:SUBDIRS=:M=:g' "${1}"
199 eend $? 207 eend $?
200 fi 208 fi
201} 209}
202 210
211# internal function
212#
213# FUNCTION: update_depmod
214# DESCRIPTION:
215# It updates the modules.dep file for the current kernel.
203update_depmod() { 216update_depmod() {
217 debug-print-function ${FUNCNAME} $*
218
204 # if we haven't determined the version yet, we need too. 219 # if we haven't determined the version yet, we need too.
205 get_version; 220 get_version;
206 221
207 ebegin "Updating module dependencies for ${KV_FULL}" 222 ebegin "Updating module dependencies for ${KV_FULL}"
208 if [ -r ${KV_OUT_DIR}/System.map ] 223 if [ -r "${KV_OUT_DIR}"/System.map ]
209 then 224 then
210 depmod -ae -F ${KV_OUT_DIR}/System.map -b ${ROOT} -r ${KV_FULL} 225 depmod -ae -F "${KV_OUT_DIR}"/System.map -b "${ROOT}" ${KV_FULL}
211 eend $? 226 eend $?
212 else 227 else
213 ewarn 228 ewarn
214 ewarn "${KV_OUT_DIR}/System.map not found." 229 ewarn "${KV_OUT_DIR}/System.map not found."
215 ewarn "You must manually update the kernel module dependencies using depmod." 230 ewarn "You must manually update the kernel module dependencies using depmod."
216 eend 1 231 eend 1
217 ewarn 232 ewarn
218 fi 233 fi
219} 234}
220 235
236# internal function
237#
238# FUNCTION: update_modules
239# DESCRIPTION:
240# It calls the update-modules utility.
221update_modules() { 241update_modules() {
242 debug-print-function ${FUNCNAME} $*
243
222 if [ -x /sbin/modules-update ] && \ 244 if [ -x /sbin/update-modules ] && \
223 grep -v -e "^#" -e "^$" ${D}/etc/modules.d/* >/dev/null 2>&1; then 245 grep -v -e "^#" -e "^$" "${D}"/etc/modules.d/* >/dev/null 2>&1; then
224 ebegin "Updating modules.conf" 246 ebegin "Updating modules.conf"
225 /sbin/modules-update 247 /sbin/update-modules
226 eend $? 248 eend $?
249 elif [ -x /sbin/update-modules ] && \
250 grep -v -e "^#" -e "^$" "${D}"/etc/modules.d/* >/dev/null 2>&1; then
251 ebegin "Updating modules.conf"
252 /sbin/update-modules
253 eend $?
227 fi 254 fi
228} 255}
229 256
257# internal function
258#
259# FUNCTION: move_old_moduledb
260# DESCRIPTION:
261# It updates the location of the database used by the module-rebuild utility.
230move_old_moduledb() { 262move_old_moduledb() {
263 debug-print-function ${FUNCNAME} $*
264
231 local OLDDIR=${ROOT}/usr/share/module-rebuild/ 265 local OLDDIR="${ROOT}"/usr/share/module-rebuild/
232 local NEWDIR=${ROOT}/var/lib/module-rebuild/ 266 local NEWDIR="${ROOT}"/var/lib/module-rebuild/
233 267
234 if [[ -f ${OLDDIR}/moduledb ]]; then 268 if [[ -f "${OLDDIR}"/moduledb ]]; then
235 [[ ! -d ${NEWDIR} ]] && mkdir -p ${NEWDIR} 269 [[ ! -d "${NEWDIR}" ]] && mkdir -p "${NEWDIR}"
236 [[ ! -f ${NEWDIR}/moduledb ]] && \ 270 [[ ! -f "${NEWDIR}"/moduledb ]] && \
237 mv ${OLDDIR}/moduledb ${NEWDIR}/moduledb 271 mv "${OLDDIR}"/moduledb "${NEWDIR}"/moduledb
238 rm -f ${OLDDIR}/* 272 rm -f "${OLDDIR}"/*
239 rmdir ${OLDDIR} 273 rmdir "${OLDDIR}"
240 fi 274 fi
241} 275}
242 276
277# internal function
278#
279# FUNCTION: update_moduledb
280# DESCRIPTION:
281# It adds the package to the /var/lib/module-rebuild/moduledb database used by the module-rebuild utility.
243update_moduledb() { 282update_moduledb() {
283 debug-print-function ${FUNCNAME} $*
284
244 local MODULEDB_DIR=${ROOT}/var/lib/module-rebuild/ 285 local MODULEDB_DIR="${ROOT}"/var/lib/module-rebuild/
245 move_old_moduledb 286 move_old_moduledb
246 287
247 if [[ ! -f ${MODULEDB_DIR}/moduledb ]]; then 288 if [[ ! -f "${MODULEDB_DIR}"/moduledb ]]; then
248 [[ ! -d ${MODULEDB_DIR} ]] && mkdir -p ${MODULEDB_DIR} 289 [[ ! -d "${MODULEDB_DIR}" ]] && mkdir -p "${MODULEDB_DIR}"
249 touch ${MODULEDB_DIR}/moduledb 290 touch "${MODULEDB_DIR}"/moduledb
250 fi 291 fi
292
251 if [[ -z $(grep ${CATEGORY}/${PN}-${PVR} ${MODULEDB_DIR}/moduledb) ]]; then 293 if ! grep -qs ${CATEGORY}/${PN}-${PVR} "${MODULEDB_DIR}"/moduledb ; then
252 einfo "Adding module to moduledb." 294 einfo "Adding module to moduledb."
253 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${MODULEDB_DIR}/moduledb 295 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> "${MODULEDB_DIR}"/moduledb
254 fi 296 fi
255} 297}
256 298
299# internal function
300#
301# FUNCTION: remove_moduledb
302# DESCRIPTION:
303# It removes the package from the /var/lib/module-rebuild/moduledb database used by
304# the module-rebuild utility.
257remove_moduledb() { 305remove_moduledb() {
306 debug-print-function ${FUNCNAME} $*
307
258 local MODULEDB_DIR=${ROOT}/var/lib/module-rebuild/ 308 local MODULEDB_DIR="${ROOT}"/var/lib/module-rebuild/
259 move_old_moduledb 309 move_old_moduledb
260 310
261 if [[ -n $(grep ${CATEGORY}/${PN}-${PVR} ${MODULEDB_DIR}/moduledb) ]]; then 311 if grep -qs ${CATEGORY}/${PN}-${PVR} "${MODULEDB_DIR}"/moduledb ; then
262 einfo "Removing ${CATEGORY}/${PN}-${PVR} from moduledb." 312 einfo "Removing ${CATEGORY}/${PN}-${PVR} from moduledb."
263 sed -ie "/.*${CATEGORY}\/${PN}-${PVR}.*/d" ${MODULEDB_DIR}/moduledb 313 sed -i -e "/.*${CATEGORY}\/${PN}-${PVR}.*/d" "${MODULEDB_DIR}"/moduledb
264 fi 314 fi
265} 315}
266 316
317# @FUNCTION: set_kvobj
318# @DESCRIPTION:
319# It sets the KV_OBJ variable.
267set_kvobj() { 320set_kvobj() {
321 debug-print-function ${FUNCNAME} $*
322
268 if kernel_is 2 6 323 if kernel_is ge 2 6
269 then 324 then
270 KV_OBJ="ko" 325 KV_OBJ="ko"
271 else 326 else
272 KV_OBJ="o" 327 KV_OBJ="o"
273 fi 328 fi
274 # Do we really need to know this? 329 # Do we really need to know this?
275 # Lets silence it. 330 # Lets silence it.
276 # einfo "Using KV_OBJ=${KV_OBJ}" 331 # einfo "Using KV_OBJ=${KV_OBJ}"
277} 332}
278 333
334get-KERNEL_CC() {
335 debug-print-function ${FUNCNAME} $*
336
337 if [[ -n ${KERNEL_CC} ]] ; then
338 echo "${KERNEL_CC}"
339 return
340 fi
341
342 local kernel_cc
343 if [ -n "${KERNEL_ABI}" ]; then
344 # In future, an arch might want to define CC_$ABI
345 #kernel_cc="$(get_abi_CC)"
346 #[ -z "${kernel_cc}" ] &&
347 kernel_cc="$(tc-getCC $(ABI=${KERNEL_ABI} get_abi_CHOST))"
348 else
349 kernel_cc=$(tc-getCC)
350 fi
351 echo "${kernel_cc}"
352}
353
354# internal function
355#
356# FUNCTION:
357# USAGE: /path/to/the/modulename_without_extension
358# RETURN: A file in /etc/modules.d/ (kernel < 2.6) or /etc/modprobe.d/ (kernel >= 2.6)
359# DESCRIPTION:
360# This function will generate and install the neccessary modprobe.d/modules.d file from the
361# information contained in the modules exported parms.
362# (see the variables MODULESD_<modulename>_ENABLED, MODULESD_<modulename>_EXAMPLES,
363# MODULESD_<modulename>_ALIASES, MODULESD_<modulename>_ADDITION and MODULESD_<modulename>_DOCS).
364#
365# At the end the documentation specified with MODULESD_<modulename>_DOCS is installed.
279generate_modulesd() { 366generate_modulesd() {
280 # This function will generate the neccessary modules.d file from the 367 debug-print-function ${FUNCNAME} $*
281 # information contained in the modules exported parms
282 368
283 local currm_path currm currm_t t myIFS myVAR 369 local currm_path currm currm_t t myIFS myVAR
284 local module_docs module_enabled module_aliases \ 370 local module_docs module_enabled module_aliases \
285 module_additions module_examples module_modinfo module_opts 371 module_additions module_examples module_modinfo module_opts
286 372
320 module_modinfo="$(modinfo -p ${currm_path}.${KV_OBJ})" 406 module_modinfo="$(modinfo -p ${currm_path}.${KV_OBJ})"
321 module_config="${T}/modulesd-${currm}" 407 module_config="${T}/modulesd-${currm}"
322 408
323 ebegin "Preparing file for modules.d" 409 ebegin "Preparing file for modules.d"
324 #----------------------------------------------------------------------- 410 #-----------------------------------------------------------------------
325 echo "# modules.d configuration file for ${currm}" >> ${module_config} 411 echo "# modules.d configuration file for ${currm}" >> "${module_config}"
326 #----------------------------------------------------------------------- 412 #-----------------------------------------------------------------------
327 [[ -n ${module_docs} ]] && \ 413 [[ -n ${module_docs} ]] && \
328 echo "# For more information please read:" >> ${module_config} 414 echo "# For more information please read:" >> "${module_config}"
329 for t in ${module_docs} 415 for t in ${module_docs}
330 do 416 do
331 echo "# ${t//*\/}" >> ${module_config} 417 echo "# ${t//*\/}" >> "${module_config}"
332 done 418 done
333 echo >> ${module_config} 419 echo >> "${module_config}"
334 420
335 #----------------------------------------------------------------------- 421 #-----------------------------------------------------------------------
336 if [[ ${module_aliases} -gt 0 ]] 422 if [[ ${module_aliases} -gt 0 ]]
337 then 423 then
338 echo "# Internal Aliases - Do not edit" >> ${module_config} 424 echo "# Internal Aliases - Do not edit" >> "${module_config}"
339 echo "# ------------------------------" >> ${module_config} 425 echo "# ------------------------------" >> "${module_config}"
340 426
341 for((t=0; t<${module_aliases}; t++)) 427 for((t=0; t<${module_aliases}; t++))
342 do 428 do
343 echo "alias $(eval echo \${MODULESD_${currm}_ALIASES[$t]})" \ 429 echo "alias $(eval echo \${MODULESD_${currm}_ALIASES[$t]})" \
344 >> ${module_config} 430 >> "${module_config}"
345 done 431 done
346 echo '' >> ${module_config} 432 echo '' >> "${module_config}"
347 fi 433 fi
348 434
349 #----------------------------------------------------------------------- 435 #-----------------------------------------------------------------------
350 if [[ -n ${module_modinfo} ]] 436 if [[ -n ${module_modinfo} ]]
351 then 437 then
352 echo >> ${module_config} 438 echo >> "${module_config}"
353 echo "# Configurable module parameters" >> ${module_config} 439 echo "# Configurable module parameters" >> "${module_config}"
354 echo "# ------------------------------" >> ${module_config} 440 echo "# ------------------------------" >> "${module_config}"
355 myIFS="${IFS}" 441 myIFS="${IFS}"
356 IFS="$(echo -en "\n\b")" 442 IFS="$(echo -en "\n\b")"
357 443
358 for t in ${module_modinfo} 444 for t in ${module_modinfo}
359 do 445 do
360 myVAR="$(echo ${t#*:} | grep -e " [0-9][ =]" | sed "s:.*\([01][= ]\).*:\1:")" 446 myVAR="$(echo ${t#*:} | grep -e " [0-9][ =]" | sed "s:.*\([01][= ]\).*:\1:")"
361 if [[ -n ${myVAR} ]] 447 if [[ -n ${myVAR} ]]
362 then 448 then
363 module_opts="${module_opts} ${t%%:*}:${myVAR}" 449 module_opts="${module_opts} ${t%%:*}:${myVAR}"
364 fi 450 fi
365 echo -e "# ${t%%:*}:\t${t#*:}" >> ${module_config} 451 echo -e "# ${t%%:*}:\t${t#*:}" >> "${module_config}"
366 done 452 done
367 IFS="${myIFS}" 453 IFS="${myIFS}"
368 echo '' >> ${module_config} 454 echo '' >> "${module_config}"
369 fi 455 fi
370 456
371 #----------------------------------------------------------------------- 457 #-----------------------------------------------------------------------
372 if [[ $(eval echo \${MODULESD_${currm}_ALIASES[0]}) == guess ]] 458 if [[ $(eval echo \${MODULESD_${currm}_ALIASES[0]}) == guess ]]
373 then 459 then
374 # So lets do some guesswork eh? 460 # So lets do some guesswork eh?
375 if [[ -n ${module_opts} ]] 461 if [[ -n ${module_opts} ]]
376 then 462 then
377 echo "# For Example..." >> ${module_config} 463 echo "# For Example..." >> "${module_config}"
378 echo "# --------------" >> ${module_config} 464 echo "# --------------" >> "${module_config}"
379 for t in ${module_opts} 465 for t in ${module_opts}
380 do 466 do
381 echo "# options ${currm} ${t//:*}=${t//*:}" >> ${module_config} 467 echo "# options ${currm} ${t//:*}=${t//*:}" >> "${module_config}"
382 done 468 done
383 echo '' >> ${module_config} 469 echo '' >> "${module_config}"
384 fi 470 fi
385 elif [[ ${module_examples} -gt 0 ]] 471 elif [[ ${module_examples} -gt 0 ]]
386 then 472 then
387 echo "# For Example..." >> ${module_config} 473 echo "# For Example..." >> "${module_config}"
388 echo "# --------------" >> ${module_config} 474 echo "# --------------" >> "${module_config}"
389 for((t=0; t<${module_examples}; t++)) 475 for((t=0; t<${module_examples}; t++))
390 do 476 do
391 echo "options $(eval echo \${MODULESD_${currm}_EXAMPLES[$t]})" \ 477 echo "options $(eval echo \${MODULESD_${currm}_EXAMPLES[$t]})" \
392 >> ${module_config} 478 >> "${module_config}"
393 done 479 done
394 echo '' >> ${module_config} 480 echo '' >> "${module_config}"
395 fi 481 fi
396 482
397 #----------------------------------------------------------------------- 483 #-----------------------------------------------------------------------
398 if [[ ${module_additions} -gt 0 ]] 484 if [[ ${module_additions} -gt 0 ]]
399 then 485 then
400 for((t=0; t<${module_additions}; t++)) 486 for((t=0; t<${module_additions}; t++))
401 do 487 do
402 echo "$(eval echo \${MODULESD_${currm}_ADDITIONS[$t]})" \ 488 echo "$(eval echo \${MODULESD_${currm}_ADDITIONS[$t]})" \
403 >> ${module_config} 489 >> "${module_config}"
404 done 490 done
405 echo '' >> ${module_config} 491 echo '' >> "${module_config}"
406 fi 492 fi
407 493
408 #----------------------------------------------------------------------- 494 #-----------------------------------------------------------------------
409 495
410 # then we install it 496 # then we install it
497 if kernel_is ge 2 6; then
498 insinto /etc/modprobe.d
499 else
411 insinto /etc/modules.d 500 insinto /etc/modules.d
501 fi
412 newins ${module_config} ${currm_path//*\/} 502 newins "${module_config}" "${currm_path//*\/}.conf"
413 503
414 # and install any documentation we might have. 504 # and install any documentation we might have.
415 [[ -n ${module_docs} ]] && dodoc ${module_docs} 505 [[ -n ${module_docs} ]] && dodoc ${module_docs}
416 done 506 done
417 eend 0 507 eend 0
418 return 0 508 return 0
419} 509}
420 510
511# internal function
512#
513# FUNCTION: find_module_params
514# USAGE: A string "NAME(LIBDIR:SRCDIR:OBJDIR)"
515# RETURN: The string "modulename:NAME libdir:LIBDIR srcdir:SRCDIR objdir:OBJDIR"
516# DESCRIPTION:
517# Analyze the specification NAME(LIBDIR:SRCDIR:OBJDIR) of one module as described in MODULE_NAMES.
421find_module_params() { 518find_module_params() {
519 debug-print-function ${FUNCNAME} $*
520
422 local matched_offset=0 matched_opts=0 test="${@}" temp_var result 521 local matched_offset=0 matched_opts=0 test="${@}" temp_var result
423 local i=0 y=0 z=0 522 local i=0 y=0 z=0
424 523
425 for((i=0; i<=${#test}; i++)) 524 for((i=0; i<=${#test}; i++))
426 do 525 do
459} 558}
460 559
461# default ebuild functions 560# default ebuild functions
462# -------------------------------- 561# --------------------------------
463 562
563# @FUNCTION: linux-mod_pkg_setup
564# @DESCRIPTION:
565# It checks the CONFIG_CHECK options (see linux-info.eclass(5)), verifies that the kernel is
566# configured, verifies that the sources are prepared, verifies that the modules support is builtin
567# in the kernel and sets the object extension KV_OBJ.
464linux-mod_pkg_setup() { 568linux-mod_pkg_setup() {
569 debug-print-function ${FUNCNAME} $*
570
571 local is_bin="${MERGE_TYPE}"
572
573 # If we are installing a binpkg, take a different path.
574 # use MERGE_TYPE if available (eapi>=4); else use non-PMS EMERGE_FROM (eapi<4)
575 if has ${EAPI} 0 1 2 3; then
576 is_bin=${EMERGE_FROM}
577 fi
578
579 if [[ ${is_bin} == binary ]]; then
580 linux-mod_pkg_setup_binary
581 return
582 fi
583
465 linux-info_pkg_setup; 584 linux-info_pkg_setup;
585 require_configured_kernel
466 check_kernel_built; 586 check_kernel_built;
467 strip_modulenames; 587 strip_modulenames;
468 [[ -n ${MODULE_NAMES} ]] && check_modules_supported 588 [[ -n ${MODULE_NAMES} ]] && check_modules_supported
469 set_kvobj; 589 set_kvobj;
470 # Commented out with permission from johnm until a fixed version for arches 590 # Commented out with permission from johnm until a fixed version for arches
471 # who intentionally use different kernel and userland compilers can be 591 # who intentionally use different kernel and userland compilers can be
472 # introduced - Jason Wever <weeve@gentoo.org>, 23 Oct 2005 592 # introduced - Jason Wever <weeve@gentoo.org>, 23 Oct 2005
473 #check_vermagic; 593 #check_vermagic;
474} 594}
475 595
596# @FUNCTION: linux-mod_pkg_setup_binary
597# @DESCRIPTION:
598# Perform all kernel option checks non-fatally, as the .config and
599# /proc/config.gz might not be present. Do not do anything that requires kernel
600# sources.
601linux-mod_pkg_setup_binary() {
602 debug-print-function ${FUNCNAME} $*
603 local new_CONFIG_CHECK
604 # ~ needs always to be quoted, else bash expands it.
605 for config in $CONFIG_CHECK ; do
606 optional='~'
607 [[ ${config:0:1} == "~" ]] && optional=''
608 new_CONFIG_CHECK="${new_CONFIG_CHECK} ${optional}${config}"
609 done
610 export CONFIG_CHECK="${new_CONFIG_CHECK}"
611 linux-info_pkg_setup;
612}
613
476strip_modulenames() { 614strip_modulenames() {
615 debug-print-function ${FUNCNAME} $*
616
477 local i 617 local i
478 for i in ${MODULE_IGNORE}; do 618 for i in ${MODULE_IGNORE}; do
479 MODULE_NAMES=${MODULE_NAMES//${i}(*} 619 MODULE_NAMES=${MODULE_NAMES//${i}(*}
480 done 620 done
481} 621}
482 622
623# @FUNCTION: linux-mod_src_compile
624# @DESCRIPTION:
625# It compiles all the modules specified in MODULE_NAMES. For each module the econf command is
626# executed only if ECONF_PARAMS is defined, the name of the target is specified by BUILD_TARGETS
627# while the options are in BUILD_PARAMS (all the modules share these variables). The compilation
628# happens inside ${srcdir}.
629#
630# Look at the description of these variables for more details.
483linux-mod_src_compile() { 631linux-mod_src_compile() {
632 debug-print-function ${FUNCNAME} $*
633
484 local modulename libdir srcdir objdir i n myARCH="${ARCH}" myABI="${ABI}" 634 local modulename libdir srcdir objdir i n myABI="${ABI}"
485 ARCH="$(tc-arch-kernel)" 635 set_arch_to_kernel
486 ABI="${KERNEL_ABI}" 636 ABI="${KERNEL_ABI}"
487 CC_HOSTCC=$(tc-getBUILD_CC)
488 CC_CC=$(tc-getCC)
489 637
490 BUILD_TARGETS=${BUILD_TARGETS:-clean module} 638 BUILD_TARGETS=${BUILD_TARGETS:-clean module}
639 strip_modulenames;
640 cd "${S}"
641 touch Module.symvers
642 for i in ${MODULE_NAMES}
643 do
644 unset libdir srcdir objdir
645 for n in $(find_module_params ${i})
646 do
647 eval ${n/:*}=${n/*:/}
648 done
649 libdir=${libdir:-misc}
650 srcdir=${srcdir:-${S}}
651 objdir=${objdir:-${srcdir}}
652
653 if [ ! -f "${srcdir}/.built" ];
654 then
655 cd "${srcdir}"
656 ln -s "${S}"/Module.symvers Module.symvers
657 einfo "Preparing ${modulename} module"
658 if [[ -n ${ECONF_PARAMS} ]]
659 then
660 econf ${ECONF_PARAMS} || \
661 die "Unable to run econf ${ECONF_PARAMS}"
662 fi
663
664 # This looks messy, but it is needed to handle multiple variables
665 # being passed in the BUILD_* stuff where the variables also have
666 # spaces that must be preserved. If don't do this, then the stuff
667 # inside the variables gets used as targets for Make, which then
668 # fails.
669 eval "emake HOSTCC=\"$(tc-getBUILD_CC)\" \
670 CROSS_COMPILE=${CHOST}- \
671 LDFLAGS=\"$(get_abi_LDFLAGS)\" \
672 ${BUILD_FIXES} \
673 ${BUILD_PARAMS} \
674 ${BUILD_TARGETS} " \
675 || die "Unable to emake HOSTCC="$(tc-getBUILD_CC)" CROSS_COMPILE=${CHOST}- LDFLAGS="$(get_abi_LDFLAGS)" ${BUILD_FIXES} ${BUILD_PARAMS} ${BUILD_TARGETS}"
676 cd "${OLDPWD}"
677 touch "${srcdir}"/.built
678 fi
679 done
680
681 set_arch_to_portage
682 ABI="${myABI}"
683}
684
685# @FUNCTION: linux-mod_src_install
686# @DESCRIPTION:
687# It install the modules specified in MODULES_NAME. The modules should be inside the ${objdir}
688# directory and they are installed inside /lib/modules/${KV_FULL}/${libdir}.
689#
690# The modprobe.d/modules.d configuration file is automatically generated if the
691# MODULESD_<modulename>_* variables are defined. The only way to stop this process is by
692# setting MODULESD_<modulename>_ENABLED=no. At the end the documentation specified via
693# MODULESD_<modulename>_DOCS is also installed.
694#
695# Look at the description of these variables for more details.
696linux-mod_src_install() {
697 debug-print-function ${FUNCNAME} $*
698
699 local modulename libdir srcdir objdir i n
700
491 strip_modulenames; 701 strip_modulenames;
492 for i in ${MODULE_NAMES} 702 for i in ${MODULE_NAMES}
493 do 703 do
494 unset libdir srcdir objdir 704 unset libdir srcdir objdir
495 for n in $(find_module_params ${i}) 705 for n in $(find_module_params ${i})
498 done 708 done
499 libdir=${libdir:-misc} 709 libdir=${libdir:-misc}
500 srcdir=${srcdir:-${S}} 710 srcdir=${srcdir:-${S}}
501 objdir=${objdir:-${srcdir}} 711 objdir=${objdir:-${srcdir}}
502 712
503 if [ ! -f "${srcdir}/.built" ];
504 then
505 cd ${srcdir}
506 einfo "Preparing ${modulename} module"
507 if [[ -n ${ECONF_PARAMS} ]]
508 then
509 econf ${ECONF_PARAMS} || \
510 die "Unable to run econf ${ECONF_PARAMS}"
511 fi
512
513 emake HOSTCC=${CC_HOSTCC} CC=${CC_CC}\
514 ${BUILD_FIXES} ${BUILD_PARAMS} ${BUILD_TARGETS} \
515 || die "Unable to make \
516 ${BUILD_FIXES} ${BUILD_PARAMS} ${BUILD_TARGETS}."
517 touch ${srcdir}/.built
518 cd ${OLDPWD}
519 fi
520 done
521
522 ARCH="${myARCH}"
523 ABI="${myABI}"
524}
525
526linux-mod_src_install() {
527 local modulename libdir srcdir objdir i n
528
529 strip_modulenames;
530 for i in ${MODULE_NAMES}
531 do
532 unset libdir srcdir objdir
533 for n in $(find_module_params ${i})
534 do
535 eval ${n/:*}=${n/*:/}
536 done
537 libdir=${libdir:-misc}
538 srcdir=${srcdir:-${S}}
539 objdir=${objdir:-${srcdir}}
540
541 einfo "Installing ${modulename} module" 713 einfo "Installing ${modulename} module"
542 cd ${objdir} || die "${objdir} does not exist" 714 cd "${objdir}" || die "${objdir} does not exist"
543 insinto /lib/modules/${KV_FULL}/${libdir} 715 insinto /lib/modules/${KV_FULL}/${libdir}
544 doins ${modulename}.${KV_OBJ} || die "doins ${modulename}.${KV_OBJ} failed" 716 doins ${modulename}.${KV_OBJ} || die "doins ${modulename}.${KV_OBJ} failed"
545 cd ${OLDPWD} 717 cd "${OLDPWD}"
546 718
547 generate_modulesd ${objdir}/${modulename} 719 generate_modulesd "${objdir}/${modulename}"
548 done 720 done
549} 721}
550 722
723# @FUNCTION: linux-mod_pkg_preinst
724# @DESCRIPTION:
725# It checks what to do after having merged the package.
726linux-mod_pkg_preinst() {
727 debug-print-function ${FUNCNAME} $*
728
729 [ -d "${D}lib/modules" ] && UPDATE_DEPMOD=true || UPDATE_DEPMOD=false
730 [ -d "${D}etc/modules.d" ] && UPDATE_MODULES=true || UPDATE_MODULES=false
731 [ -d "${D}lib/modules" ] && UPDATE_MODULEDB=true || UPDATE_MODULEDB=false
732}
733
734# @FUNCTION: linux-mod_pkg_postinst
735# @DESCRIPTION:
736# It executes /sbin/depmod and adds the package to the /var/lib/module-rebuild/moduledb
737# database (if ${D}/lib/modules is created) and it runs /sbin/update-modules
738# (if ${D}/etc/modules.d is created).
551linux-mod_pkg_postinst() { 739linux-mod_pkg_postinst() {
552 update_depmod; 740 debug-print-function ${FUNCNAME} $*
553 update_modules;
554 update_moduledb;
555}
556 741
742 ${UPDATE_DEPMOD} && update_depmod;
743 ${UPDATE_MODULES} && update_modules;
744 ${UPDATE_MODULEDB} && update_moduledb;
745}
746
747# @FUNCTION: linux-mod_pkg_postrm
748# @DESCRIPTION:
749# It removes the package from the /var/lib/module-rebuild/moduledb database but it doens't
750# call /sbin/depmod and /sbin/update-modules because the modules are still installed.
557linux-mod_pkg_postrm() { 751linux-mod_pkg_postrm() {
752 debug-print-function ${FUNCNAME} $*
558 remove_moduledb; 753 remove_moduledb;
559} 754}

Legend:
Removed from v.1.64  
changed lines
  Added in v.1.108

  ViewVC Help
Powered by ViewVC 1.1.20